'use strict';
import { GameDeckMode } from '../../common/utils/const/game-deck-mode-enum';
import { PhaserScene } from '../../common/utils/const/phaser-scene-enum';
import Phaser from 'phaser';

export default class MainMenuScene extends Phaser.Scene {

  constructor(menuEventListener) {
    super({ key: PhaserScene.MAIN_MENU, active: false });
    this.menuEventListener = menuEventListener;

  }

  preload() {
    console.log('Preload');
    this.load.image('game-cover', '../../assets/twelveHeroes_cover.png');
    this.load.html('main-menu', '../../assets/html/main-menu.html');
  }

  create() {
    console.log('create');
    let background = this.add.image(0, 0, 'game-cover');
    background.setOrigin(0, 0);

    let element = this.add.dom(400, 100).createFromCache('main-menu');
    let connectButton = element.getChildByName('loginButton');
    let username = element.getChildByName('username');
    let connectionStatus = element.getChildByID('connectionStatus');
    let onlineGame = element.getChildByName('onlineGame');

    element.setPerspective(800);

    element.addListener('click');

    username.addEventListener("keyup", event => {
      if (connectButton.value === 'Connect') {
        if (event.key !== "Enter") return;
        connectButton.click();
        event.preventDefault();
      }
    });

    console.log(connectButton);
    connectButton.focus();
    element.on('click', function (event) {
      console.log(event);
      let eventName = event.target.name;

      switch (eventName) {
        case "loginButton":
          if (connectButton.value === 'Connect') {
            if (username.value !== '') {
              connectButton.disabled=true;
              connectionStatus.innerText = 'Connecting...';
              console.log(username.value);
              console.log(' log  :' + onlineGame.disabled);
              setTimeout(() => {
                connectionStatus.innerText = 'Connected as ' + username.value;
                onlineGame.disabled = false;
                connectButton.value = "Disconnect";

              connectButton.disabled=false;
              }, 1500);
            } else {
              connectionStatus.innerText = 'Not Connected : Enter Username';
            }
          } else {
            connectButton.disabled=true;
              connectionStatus.innerText = `Disconnecting ${username.value}...`;

              setTimeout(() => {
                connectionStatus.innerText = 'Not Connected';
                onlineGame.disabled = true;
                connectButton.value = "Connect";
                connectButton.disabled=false;
                username.value='';
              }, 500);
          }
          break;
        // case "onlineGame":

        //   break;
        // case "localGame":

        //   break;

        default:
          break;
      }
    });

    this.tweens.add({
      targets: element,
      y: 215,
      duration: 2300,
      ease: 'Power3'
    });
    //this.add.dom



    // TODO : Display main menu
    // Create new scenes : Local player room / Multi player room
    // Pass to them the event listener
    // On local player room, user can enter player names, selected color, game deck mode & rules

    // FOR TESTING
    //this.fakeNewPnpGameSelected();
  }

  update() {

  }

  fakeNewPnpGameSelected() {
    setTimeout(() => {
      let pBlueName = prompt("Player blue name : ");
      let pRedName = prompt("Player red name : ");

      //let gameDeckModeOptions = Object.values(GameDeckMode);
      //let gameDeckMode = Utils.promptSelectAmongOptions("Select Deck Mode", gameDeckModeOptions);
      let gameDeckMode = "factions";
      let advancedRules = [];
      console.log("Calling listener");
      this.menuEventListener.onNewPnpGame(pBlueName, pRedName, gameDeckMode, advancedRules);
    }, 1000);
  }
}
